#include <Ethernet.h>
#include <SPI.h>
#include <FlexRig.h>
#include <FlexBandData.h>
#include <FlexCat.h>


//Ethernet Shield Mac Address
//You can get it from adesive label on the shield
byte mac[] = {0x90, 0xA2, 0xDA, 0x0F, 0xC2, 0x43};

//Rig instance
FlexRig fRig;
FlexBandData fbData;
FlexCat fCat;
int oldVFOA;
int oldVFOB;



void setup() {
  Serial.begin(115200);
  Serial3.begin(38400);
  Serial3.flush();
  Serial.println("=== Started DHCP request");
  getIpAddress();
  //fRig=FlexRig::findAFlex(NULL);  
  fRig=FlexRig::findAFlex("2114-420A-6300-3136"); 
  fRig.connect(); 
  if (fRig.connected) {
     fbData.begin(fRig);
     int oldVFOA=fRig.slice[0].RF_frequency;
     int oldVFOB=fRig.slice[1].RF_frequency;
     fbData.attachSliceEventFunc(sliceEventHandler);
     Serial.println("Connected to Flex Rig");
  } 
}

void loop() {
  fRig.readEthernetData();    //Never remove this from loop() routine
  fbData.process(fRig); 
  fCat.process(fRig);
}

//Ethernet DHCP service routine
void getIpAddress() {
  // start the Ethernet connection:
  Serial.println("=== Waiting for IP address");
  if (Ethernet.begin(mac) == 0) {
    Serial.println("Failed to configure Ethernet using DHCP");
    //do nothing forevermore
    for (;;)
      ;
  }
  Serial.print("IP address is: ");
  for (byte thisByte = 0; thisByte < 3; thisByte++) {
    // print the value of each byte of the IP address:
    Serial.print(Ethernet.localIP()[thisByte], DEC);
    Serial.print(".");
  }
  Serial.print(Ethernet.localIP()[3], DEC); 
  Serial.println();
}

void sliceEventHandler() {  
  if (oldVFOA-fRig.slice[0].RF_frequency) {
    //Serial.println("VFO-A updated");
    oldVFOA=fRig.slice[0].RF_frequency;
    fCat.sendFA(fRig.slice[0].RF_frequency);
  }
  if (oldVFOB-fRig.slice[1].RF_frequency) {
    //Serial.println("VFO-B updated");
    oldVFOB=fRig.slice[1].RF_frequency;
    fCat.sendFB(fRig.slice[1].RF_frequency);
  } 
}
